---@diagnostic disable: duplicate-index -- Some names changed, but looks like these changes were within products. Using live version last when generating to use live as current value
-- Run this to update
-- for ver in wowlivetest wow_beta wowxptr wow wow_classic_beta wow_classic_ptr wow_classic wow_classic_era_ptr wow_classic_era; do curl https://wago.tools/db2/Difficulty/csv\?product=$ver | tail -n +2; done | tr -d \" | awk -F, '{printf "\t[%d] = {difficultyName = \"%s\", instanceTypeId = %d, minPlayers = %d, maxPlayers = %d},\n",$1,$2,$3,$7,$8}' | sort -t ']' -k 1.3 -n | uniq
local data = DBM.Test.CreateSharedModule("Data.Difficulties", {
	-- TODO: why do many of our TWW tests from alpha/beta testing use a different difficultyName? "mythic" vs. "Mythic"?
	-- I don't think it matters because no one should be using the name for anything important, but it's still odd and maybe wrong
	[1] = {difficultyName = "Normal", instanceTypeId = 1, minPlayers = 5, maxPlayers = 5},
	[2] = {difficultyName = "Heroic", instanceTypeId = 1, minPlayers = 5, maxPlayers = 5},
	[3] = {difficultyName = "10 Player", instanceTypeId = 2, minPlayers = 10, maxPlayers = 10},
	[4] = {difficultyName = "25 Player", instanceTypeId = 2, minPlayers = 25, maxPlayers = 25},
	[5] = {difficultyName = "10 Player (Heroic)", instanceTypeId = 2, minPlayers = 10, maxPlayers = 10},
	[6] = {difficultyName = "25 Player (Heroic)", instanceTypeId = 2, minPlayers = 25, maxPlayers = 25},
	[7] = {difficultyName = "Looking For Raid", instanceTypeId = 2, minPlayers = 25, maxPlayers = 25},
	[8] = {difficultyName = "Mythic Keystone", instanceTypeId = 1, minPlayers = 5, maxPlayers = 5},
	[9] = {difficultyName = "40 Player", instanceTypeId = 2, minPlayers = 40, maxPlayers = 40},
	[11] = {difficultyName = "Heroic Scenario", instanceTypeId = 5, minPlayers = 3, maxPlayers = 3},
	[12] = {difficultyName = "Normal Scenario", instanceTypeId = 5, minPlayers = 5, maxPlayers = 5},
	[14] = {difficultyName = "Normal", instanceTypeId = 2, minPlayers = 10, maxPlayers = 30},
	[15] = {difficultyName = "Heroic", instanceTypeId = 2, minPlayers = 10, maxPlayers = 30},
	[16] = {difficultyName = "Mythic", instanceTypeId = 2, minPlayers = 20, maxPlayers = 20},
	[17] = {difficultyName = "Looking For Raid", instanceTypeId = 2, minPlayers = 10, maxPlayers = 30},
	[18] = {difficultyName = "Event", instanceTypeId = 2, minPlayers = 40, maxPlayers = 40},
	[19] = {difficultyName = "Event", instanceTypeId = 1, minPlayers = 5, maxPlayers = 5},
	[20] = {difficultyName = "Event Scenario", instanceTypeId = 5, minPlayers = 25, maxPlayers = 25},
	[23] = {difficultyName = "Mythic", instanceTypeId = 1, minPlayers = 5, maxPlayers = 5},
	[24] = {difficultyName = "Timewalking", instanceTypeId = 1, minPlayers = 5, maxPlayers = 5},
	[25] = {difficultyName = "World PvP Scenario", instanceTypeId = 5, minPlayers = 0, maxPlayers = 40},
	[29] = {difficultyName = "PvEvP Scenario", instanceTypeId = 3, minPlayers = 0, maxPlayers = 5},
	[30] = {difficultyName = "Event", instanceTypeId = 5, minPlayers = 6, maxPlayers = 6},
	[32] = {difficultyName = "World PvP Scenario", instanceTypeId = 5, minPlayers = 0, maxPlayers = 40},
	[33] = {difficultyName = "Timewalking", instanceTypeId = 2, minPlayers = 10, maxPlayers = 30},
	[34] = {difficultyName = "PvP", instanceTypeId = 3, minPlayers = 5, maxPlayers = 5},
	[38] = {difficultyName = "Normal", instanceTypeId = 5, minPlayers = 1, maxPlayers = 3},
	[39] = {difficultyName = "Heroic", instanceTypeId = 5, minPlayers = 1, maxPlayers = 3},
	[40] = {difficultyName = "Mythic", instanceTypeId = 5, minPlayers = 1, maxPlayers = 3},
	[45] = {difficultyName = "PvP", instanceTypeId = 5, minPlayers = 1, maxPlayers = 3},
	[147] = {difficultyName = "Normal", instanceTypeId = 5, minPlayers = 5, maxPlayers = 5},
	[148] = {difficultyName = "20 Player", instanceTypeId = 2, minPlayers = 20, maxPlayers = 20},
	[149] = {difficultyName = "Heroic", instanceTypeId = 5, minPlayers = 10, maxPlayers = 30},
	[150] = {difficultyName = "Normal Scaling (1-5)", instanceTypeId = 1, minPlayers = 1, maxPlayers = 5},
	[150] = {difficultyName = "Normal", instanceTypeId = 1, minPlayers = 1, maxPlayers = 5},
	[151] = {difficultyName = "Looking For Raid", instanceTypeId = 2, minPlayers = 10, maxPlayers = 30},
	[152] = {difficultyName = "Visions of N'Zoth", instanceTypeId = 5, minPlayers = 1, maxPlayers = 5},
	[153] = {difficultyName = "Teeming Island", instanceTypeId = 5, minPlayers = 10, maxPlayers = 10},
	[167] = {difficultyName = "Torghast", instanceTypeId = 5, minPlayers = 1, maxPlayers = 5},
	[168] = {difficultyName = "Path of Ascension: Courage", instanceTypeId = 5, minPlayers = 1, maxPlayers = 1},
	[169] = {difficultyName = "Path of Ascension: Loyalty", instanceTypeId = 5, minPlayers = 1, maxPlayers = 1},
	[170] = {difficultyName = "Path of Ascension: Wisdom", instanceTypeId = 5, minPlayers = 1, maxPlayers = 1},
	[171] = {difficultyName = "Path of Ascension: Humility", instanceTypeId = 5, minPlayers = 1, maxPlayers = 1},
	[172] = {difficultyName = "World Boss", instanceTypeId = 0, minPlayers = 1, maxPlayers = 40},
	[173] = {difficultyName = "Normal", instanceTypeId = 1, minPlayers = 5, maxPlayers = 5},
	[174] = {difficultyName = "Heroic", instanceTypeId = 1, minPlayers = 5, maxPlayers = 5},
	[175] = {difficultyName = "10 Player", instanceTypeId = 2, minPlayers = 10, maxPlayers = 10},
	[176] = {difficultyName = "25 Player", instanceTypeId = 2, minPlayers = 25, maxPlayers = 25},
	[184] = {difficultyName = "Normal", instanceTypeId = 1, minPlayers = 5, maxPlayers = 5},
	[185] = {difficultyName = "20 Player", instanceTypeId = 2, minPlayers = 20, maxPlayers = 20},
	[186] = {difficultyName = "40 Player", instanceTypeId = 2, minPlayers = 40, maxPlayers = 40},
	[192] = {difficultyName = "Challenge Level 1", instanceTypeId = 0, minPlayers = 1, maxPlayers = 40},
	[193] = {difficultyName = "10 Player (Heroic)", instanceTypeId = 2, minPlayers = 10, maxPlayers = 10},
	[194] = {difficultyName = "25 Player (Heroic)", instanceTypeId = 2, minPlayers = 25, maxPlayers = 25},
	[197] = {difficultyName = "10 Player", instanceTypeId = 2, minPlayers = 10, maxPlayers = 10},
	[198] = {difficultyName = "Normal", instanceTypeId = 1, minPlayers = 10, maxPlayers = 10},
	[201] = {difficultyName = "Normal", instanceTypeId = 1, minPlayers = 5, maxPlayers = 5},
	[202] = {difficultyName = "Difficulty A", instanceTypeId = 1, minPlayers = 5, maxPlayers = 5},
	[203] = {difficultyName = "Difficulty B", instanceTypeId = 1, minPlayers = 5, maxPlayers = 5},
	[204] = {difficultyName = "Difficulty C", instanceTypeId = 1, minPlayers = 5, maxPlayers = 5},
	[205] = {difficultyName = "Dungeon Follower", instanceTypeId = 1, minPlayers = 1, maxPlayers = 5},
	[205] = {difficultyName = "Follower", instanceTypeId = 1, minPlayers = 5, maxPlayers = 5},
	[207] = {difficultyName = "Normal", instanceTypeId = 1, minPlayers = 1, maxPlayers = 1},
	[208] = {difficultyName = "Delves", instanceTypeId = 5, minPlayers = 1, maxPlayers = 5},
	[213] = {difficultyName = "Infinite", instanceTypeId = 1, minPlayers = 5, maxPlayers = 5},
	[214] = {difficultyName = "DNT - Internal only", instanceTypeId = 1, minPlayers = 5, maxPlayers = 5},
	[215] = {difficultyName = "Normal", instanceTypeId = 1, minPlayers = 20, maxPlayers = 20},
	[216] = {difficultyName = "Quest", instanceTypeId = 1, minPlayers = 5, maxPlayers = 5},
	[220] = {difficultyName = "Story", instanceTypeId = 2, minPlayers = 1, maxPlayers = 10},
	[220] = {difficultyName = "Story", instanceTypeId = 2, minPlayers = 10, maxPlayers = 10},
	[226] = {difficultyName = "20 Player", instanceTypeId = 2, minPlayers = 20, maxPlayers = 20},
})

return data
